require "defines"

local itemCollisionDistance = 0.34375--0.29
local droppedItemName = "item-on-ground"
local floor=math.floor
local random = math.random

--glob.tospill={}

for _,f in pairs(game.forces) do
	f.technologies["advanced-material-processing"].reload()
	if f.technologies["advanced-material-processing"].researched then
		f.recipes["recycling-machine"].enabled=true
		f.recipes["separate-scrap"].enabled=true
	end
end

game.onevent(defines.events.ontick,function(event)

--space for scavengerchests

if glob.spill then for _,spillist in pairs(glob.spill) do
	local position = spillist.position
	local startx,starty=position.x,position.y
	local newpos = {x=startx,y=starty}
	local toplace = {name="item-on-ground",position=newpos,stack = {count = 1}}
	local vectorx,vectory = itemCollisionDistance,itemCollisionDistance
	local side = 0
	
	for item,count in pairs(spillist.spill) do
		toplace.stack.name=item
		for n = 1, count do
			retry = true
			--failcount = 0
			while retry do
				if side==0 then
					newpos.x=startx+vectorx
					newpos.y=starty+vectory
				elseif side==1 then
					newpos.x=startx+vectory
					newpos.y=starty+vectorx
				elseif side==2 then
					newpos.x=startx-vectorx
					newpos.y=starty+vectory
				elseif side==3 then
					newpos.x=startx-vectory
					newpos.y=starty+vectorx
				elseif side==4 then
					newpos.x=startx-vectorx
					newpos.y=starty-vectory
				elseif side==5 then
					newpos.x=startx-vectory
					newpos.y=starty-vectorx
				elseif side==6 then
					newpos.x=startx+vectorx
					newpos.y=starty-vectory
				elseif side==7 then
					newpos.x=startx+vectory
					newpos.y=starty-vectorx
				end
				if game.canplaceentity(toplace) then
					game.createentity(toplace)
					retry = false
				end
				if side==7 then
					side = 0
					if vectorx==vectory then
						vectorx=0--itemCollisionDistance
						vectory=vectory + itemCollisionDistance
					else
						vectorx = vectorx + itemCollisionDistance
					end
				else
					side = side + 1
				end
			end
		end
	end
end end

glob.spill=nil

end)

game.onevent(defines.events.onentitydied, function(event)
	local entity = event.entity
	if not entity.hasitemsinside() then return end
	local inventories={}
	for i=1,9 do
		if pcall(function() inventories[i]=entity.getinventory(i) end) then end
	end
	
	local spillCount
	local retry
	
	local gonnaspill={position=event.entity.position,spill={}}
	local invencontents-- = inventory.getcontents()
	for _,inventory in pairs(inventories) do
		invencontents = inventory.getcontents()
		if invencontents and next(invencontents)~=nil then
			for item,count in pairs(invencontents) do
				count = random(0,count)
				if count>0 then 
					gonnaspill.spill[item]=(gonnaspill.spill[item] or 0)+count
					--game.player.print("added "..count..item.." to spill list")
				end
			end
			inventory.clear()
		end
	end
	if next(gonnaspill.spill)~=nil then
		if glob.spill==nil then glob.spill={} end
		table.insert(glob.spill,gonnaspill)
	end
	--game.player.print(serpent.line(glob.spill))
end)